// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rover_msgs:msg/RawCommand.idl
// generated code does not contain a copyright notice

#ifndef ROVER_MSGS__MSG__DETAIL__RAW_COMMAND__STRUCT_HPP_
#define ROVER_MSGS__MSG__DETAIL__RAW_COMMAND__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__rover_msgs__msg__RawCommand __attribute__((deprecated))
#else
# define DEPRECATED__rover_msgs__msg__RawCommand __declspec(deprecated)
#endif

namespace rover_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RawCommand_
{
  using Type = RawCommand_<ContainerAllocator>;

  explicit RawCommand_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->verb = 0;
      this->arg = 0;
    }
  }

  explicit RawCommand_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->verb = 0;
      this->arg = 0;
    }
  }

  // field types and members
  using _verb_type =
    uint8_t;
  _verb_type verb;
  using _arg_type =
    uint8_t;
  _arg_type arg;

  // setters for named parameter idiom
  Type & set__verb(
    const uint8_t & _arg)
  {
    this->verb = _arg;
    return *this;
  }
  Type & set__arg(
    const uint8_t & _arg)
  {
    this->arg = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rover_msgs::msg::RawCommand_<ContainerAllocator> *;
  using ConstRawPtr =
    const rover_msgs::msg::RawCommand_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rover_msgs::msg::RawCommand_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rover_msgs::msg::RawCommand_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rover_msgs__msg__RawCommand
    std::shared_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rover_msgs__msg__RawCommand
    std::shared_ptr<rover_msgs::msg::RawCommand_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RawCommand_ & other) const
  {
    if (this->verb != other.verb) {
      return false;
    }
    if (this->arg != other.arg) {
      return false;
    }
    return true;
  }
  bool operator!=(const RawCommand_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RawCommand_

// alias to use template instance with default allocator
using RawCommand =
  rover_msgs::msg::RawCommand_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rover_msgs

#endif  // ROVER_MSGS__MSG__DETAIL__RAW_COMMAND__STRUCT_HPP_
