// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rover_msgs:msg/RawMotorCommand.idl
// generated code does not contain a copyright notice

#ifndef ROVER_MSGS__MSG__DETAIL__RAW_MOTOR_COMMAND__STRUCT_HPP_
#define ROVER_MSGS__MSG__DETAIL__RAW_MOTOR_COMMAND__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__rover_msgs__msg__RawMotorCommand __attribute__((deprecated))
#else
# define DEPRECATED__rover_msgs__msg__RawMotorCommand __declspec(deprecated)
#endif

namespace rover_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RawMotorCommand_
{
  using Type = RawMotorCommand_<ContainerAllocator>;

  explicit RawMotorCommand_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->left = 0;
      this->right = 0;
      this->flipper = 0;
    }
  }

  explicit RawMotorCommand_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->left = 0;
      this->right = 0;
      this->flipper = 0;
    }
  }

  // field types and members
  using _left_type =
    uint8_t;
  _left_type left;
  using _right_type =
    uint8_t;
  _right_type right;
  using _flipper_type =
    uint8_t;
  _flipper_type flipper;

  // setters for named parameter idiom
  Type & set__left(
    const uint8_t & _arg)
  {
    this->left = _arg;
    return *this;
  }
  Type & set__right(
    const uint8_t & _arg)
  {
    this->right = _arg;
    return *this;
  }
  Type & set__flipper(
    const uint8_t & _arg)
  {
    this->flipper = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rover_msgs::msg::RawMotorCommand_<ContainerAllocator> *;
  using ConstRawPtr =
    const rover_msgs::msg::RawMotorCommand_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rover_msgs::msg::RawMotorCommand_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rover_msgs::msg::RawMotorCommand_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rover_msgs__msg__RawMotorCommand
    std::shared_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rover_msgs__msg__RawMotorCommand
    std::shared_ptr<rover_msgs::msg::RawMotorCommand_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RawMotorCommand_ & other) const
  {
    if (this->left != other.left) {
      return false;
    }
    if (this->right != other.right) {
      return false;
    }
    if (this->flipper != other.flipper) {
      return false;
    }
    return true;
  }
  bool operator!=(const RawMotorCommand_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RawMotorCommand_

// alias to use template instance with default allocator
using RawMotorCommand =
  rover_msgs::msg::RawMotorCommand_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rover_msgs

#endif  // ROVER_MSGS__MSG__DETAIL__RAW_MOTOR_COMMAND__STRUCT_HPP_
