// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rover_msgs:msg/RawMotorCommand.idl
// generated code does not contain a copyright notice
#include "rover_msgs/msg/detail/raw_motor_command__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
rover_msgs__msg__RawMotorCommand__init(rover_msgs__msg__RawMotorCommand * msg)
{
  if (!msg) {
    return false;
  }
  // left
  // right
  // flipper
  return true;
}

void
rover_msgs__msg__RawMotorCommand__fini(rover_msgs__msg__RawMotorCommand * msg)
{
  if (!msg) {
    return;
  }
  // left
  // right
  // flipper
}

bool
rover_msgs__msg__RawMotorCommand__are_equal(const rover_msgs__msg__RawMotorCommand * lhs, const rover_msgs__msg__RawMotorCommand * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // left
  if (lhs->left != rhs->left) {
    return false;
  }
  // right
  if (lhs->right != rhs->right) {
    return false;
  }
  // flipper
  if (lhs->flipper != rhs->flipper) {
    return false;
  }
  return true;
}

bool
rover_msgs__msg__RawMotorCommand__copy(
  const rover_msgs__msg__RawMotorCommand * input,
  rover_msgs__msg__RawMotorCommand * output)
{
  if (!input || !output) {
    return false;
  }
  // left
  output->left = input->left;
  // right
  output->right = input->right;
  // flipper
  output->flipper = input->flipper;
  return true;
}

rover_msgs__msg__RawMotorCommand *
rover_msgs__msg__RawMotorCommand__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rover_msgs__msg__RawMotorCommand * msg = (rover_msgs__msg__RawMotorCommand *)allocator.allocate(sizeof(rover_msgs__msg__RawMotorCommand), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rover_msgs__msg__RawMotorCommand));
  bool success = rover_msgs__msg__RawMotorCommand__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rover_msgs__msg__RawMotorCommand__destroy(rover_msgs__msg__RawMotorCommand * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rover_msgs__msg__RawMotorCommand__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rover_msgs__msg__RawMotorCommand__Sequence__init(rover_msgs__msg__RawMotorCommand__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rover_msgs__msg__RawMotorCommand * data = NULL;

  if (size) {
    data = (rover_msgs__msg__RawMotorCommand *)allocator.zero_allocate(size, sizeof(rover_msgs__msg__RawMotorCommand), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rover_msgs__msg__RawMotorCommand__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rover_msgs__msg__RawMotorCommand__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rover_msgs__msg__RawMotorCommand__Sequence__fini(rover_msgs__msg__RawMotorCommand__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rover_msgs__msg__RawMotorCommand__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rover_msgs__msg__RawMotorCommand__Sequence *
rover_msgs__msg__RawMotorCommand__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rover_msgs__msg__RawMotorCommand__Sequence * array = (rover_msgs__msg__RawMotorCommand__Sequence *)allocator.allocate(sizeof(rover_msgs__msg__RawMotorCommand__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rover_msgs__msg__RawMotorCommand__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rover_msgs__msg__RawMotorCommand__Sequence__destroy(rover_msgs__msg__RawMotorCommand__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rover_msgs__msg__RawMotorCommand__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rover_msgs__msg__RawMotorCommand__Sequence__are_equal(const rover_msgs__msg__RawMotorCommand__Sequence * lhs, const rover_msgs__msg__RawMotorCommand__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rover_msgs__msg__RawMotorCommand__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rover_msgs__msg__RawMotorCommand__Sequence__copy(
  const rover_msgs__msg__RawMotorCommand__Sequence * input,
  rover_msgs__msg__RawMotorCommand__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rover_msgs__msg__RawMotorCommand);
    rover_msgs__msg__RawMotorCommand * data =
      (rover_msgs__msg__RawMotorCommand *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rover_msgs__msg__RawMotorCommand__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rover_msgs__msg__RawMotorCommand__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rover_msgs__msg__RawMotorCommand__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
